import { FieldOptions } from "./core";
import { TFunction } from "./typer";
import { T } from "./types";
export declare function Of(type?: () => any, options?: FieldOptions): (target: any, key: string) => void;
export declare function Producer(target: any, key: string): void;
export declare function Entity<T extends {
    new (...args: any[]): {};
}>(constructor: T): T;
export declare namespace Entity {
    var of: <T_1>() => (data: Partial<T_1>) => T_1;
}
export declare function type(type: (t: TFunction) => T): (target: any, key: string) => void;
export declare function entity(): <C extends new (...args: any[]) => {}>(constr: C) => C;
export declare namespace entity {
    var of: <T_1>() => (data: Partial<T_1>) => T_1;
}
