import { T, TArray, TRecord, TUnion, Entity } from "./types";
declare function t(constr: Function): T;
declare function t(t: T): T;
declare namespace t {
    var union: {
        (...args: (TRecord | Entity<unknown>)[]): TUnion;
        (...args: Entity<unknown>[]): TUnion;
        (...args: (StringConstructor | BooleanConstructor | NumberConstructor)[]): TUnion;
    };
    var array: {
        (arg: Function): TArray;
        (arg: T): TArray;
    };
    var record: {
        (key: Function, value: Function): TRecord;
        (key: Function, value: T): TRecord;
    };
    var custom: (callbackfn: (v: any) => any) => T;
}
export declare type TFunction = typeof t;
export { t };
